#*****************************************************************************
# a simple, empty pop-up window with buttons on the bottom
# 
# -parent "<window which starts FR_popupWindow2> | . (default)"
# -title "<your window title> | empty (default)"
# -button "Dismiss | OkChancel (default)"
#
# Author: Falk Richter, falk.richter@yandex.com, 2022
# $Id:$
#*****************************************************************************

package provide FR_popupWindow2 0.1

package require FR_general

############################################################################## 
# generate a new namespace
############################################################################## 
namespace eval ::FR_popupWindow2 {
  variable Local

  namespace export create
}


proc ::FR_popupWindow2::buttonaction {FR_pW_path RETURNVALUE} {
 variable Local
  
 if { $RETURNVALUE } \
 {
  set Local($FR_pW_path,RETURN) [.$Local($FR_pW_path,main).entrybox get]
 } else \
 {
  set Local($FR_pW_path,RETURN) ""
 }
  
 focus $Local($FR_pW_path,PARENT)
 destroy .$FR_pW_path
 set Local($FR_pW_path,STOP) 1
}


############################################################################## 
# create a new pop-up window
############################################################################## 
proc ::FR_popupWindow2::create {args} {
 variable Local
 
 # first we generate a toplevel name who doesn't exist yet
 set i 1
 while {[winfo exists .popup_window$i]} {incr i}
 set FR_pW_path "popup_window$i"
 
# the default settings
 set Local($FR_pW_path,PARENT) .
 set Local($FR_pW_path,TITLE) ""
 set Local($FR_pW_path,BUTTONS) "okcancel"
 
 set Local($FR_pW_path,STOP) 0
 set Local($FR_pW_path,RETURN) ""
 
 
 for {set i 0} {$i < [llength $args]} {incr i 2} \
  {
   set arg [lindex $args $i]
   switch -glob -- $arg \
    {
     -type         {set Local($FR_pW_path,TYPE) [lindex $args [expr {$i+1}]]} \
     -parent       {set Local($FR_pW_path,PARENT) [lindex $args [expr {$i+1}]]} \
     -title        {set Local($FR_pW_path,TITLE) [lindex $args [expr {$i+1}]]} \
     -initialinput {set Local($FR_pW_path,INI_INPUT) [lindex $args [expr {$i+1}]]} \
     -description  {set Local($FR_pW_path,DESCRIPTION) [lindex $args [expr {$i+1}]]} \
     -button       {set Local($FR_pW_path,BUTTONS) [lindex $args [expr {$i+1}]]} \
     --            {break} \
     *             {puts "Unknown option: $arg"; exit 1}
    }
   }

   
 if { $Local($FR_pW_path,TYPE) eq "Entry" } \
 {
  if {$Local($FR_pW_path,TITLE) eq ""} {set Local($FR_pW_path,TITLE) [msgcat::mc "Entry-box"]}
 }


 toplevel .$FR_pW_path
 wm title .$FR_pW_path $Local($FR_pW_path,TITLE)
 wm withdraw .$FR_pW_path

 frame .$FR_pW_path.frame1 -relief flat
 frame .$FR_pW_path.frame2 -relief flat

 pack  .$FR_pW_path.frame1 -side top -expand yes -fill both -padx 5 -pady 5
 pack  .$FR_pW_path.frame2 -side top -fill x

 #---We set a variable for each frame - so we can change the order of the frames later easier 
 set Local($FR_pW_path,main) "$FR_pW_path.frame1"
 set Local($FR_pW_path,bottom) "$FR_pW_path.frame2"
 
 label .$Local($FR_pW_path,main).description -justify left -text $Local($FR_pW_path,DESCRIPTION)
 
 entry .$Local($FR_pW_path,main).entrybox -width 35 -background white -xscrollcommand ".$Local($FR_pW_path,main).xsbar set"
 scrollbar .$Local($FR_pW_path,main).xsbar -orient horizontal -command ".$Local($FR_pW_path,main).entrybox xview"

 grid .$Local($FR_pW_path,main).description -row 0 -sticky ws -padx 5 -pady 5
 grid .$Local($FR_pW_path,main).entrybox -row 1 -sticky ew -padx 5
 grid .$Local($FR_pW_path,main).xsbar -row 2 -sticky ew -padx 5 -pady {0 5}
 grid columnconfigure .$Local($FR_pW_path,main) 0 -weight 1
 grid rowconfigure .$Local($FR_pW_path,main) 0 -weight 1

  
 if { $Local($FR_pW_path,INI_INPUT) ne "" } \
 {
  .$Local($FR_pW_path,main).entrybox insert end $Local($FR_pW_path,INI_INPUT)
  .$Local($FR_pW_path,main).entrybox selection range 0 end
 }
 
 if { $Local($FR_pW_path,BUTTONS) eq "Dismiss" } \
 {
  button .$Local($FR_pW_path,bottom).cancel -text [msgcat::mc "Dismiss"] -state normal -command [list ::FR_popupWindow2::buttonaction $FR_pW_path 0]

  pack .$Local($FR_pW_path,bottom).cancel -side left -padx 5 -pady 5 -expand yes -fill x
  
  bind .$FR_pW_path <KeyPress-Escape> [list .$Local($FR_pW_path,bottom).cancel invoke]
 }
 
 if { $Local($FR_pW_path,BUTTONS) eq "okcancel" } \
 {
  set BUTTONTEXT [::FR_general::ButtonsWithSameWidth [list [msgcat::mc "Ok"] [msgcat::mc "Cancel"]]]
  
  button .$Local($FR_pW_path,bottom).cancel -text [lindex $BUTTONTEXT 1] -state normal -width [lindex $BUTTONTEXT 2] -command [list ::FR_popupWindow2::buttonaction $FR_pW_path 0]
   
  button .$Local($FR_pW_path,bottom).okay -text [lindex $BUTTONTEXT 0] -state normal -width [lindex $BUTTONTEXT 2] -command [list ::FR_popupWindow2::buttonaction $FR_pW_path 1]
   
  pack .$Local($FR_pW_path,bottom).okay -side left -padx {5 0} -pady 5 -expand yes -fill x
  pack .$Local($FR_pW_path,bottom).cancel -side left -padx 5 -pady 5 -expand yes -fill x
  
  bind .$FR_pW_path <KeyPress-Escape> [list .$Local($FR_pW_path,bottom).cancel invoke]
  bind .$FR_pW_path <KeyPress-Return> [list .$Local($FR_pW_path,bottom).okay invoke]
 }
 
 ::FR_general::CenterWindow .$FR_pW_path $Local($FR_pW_path,PARENT)
 wm deiconify .$FR_pW_path
 wm protocol .$FR_pW_path WM_DELETE_WINDOW [list .$Local($FR_pW_path,bottom).cancel invoke]
 
 focus .$Local($FR_pW_path,main).entrybox
 
 vwait ::FR_popupWindow2::Local($FR_pW_path,STOP)
 return $Local($FR_pW_path,RETURN)
}

