#---the dialog to show the unused translations

proc ::tk_msg::UnusedTranslationsSub {} \
{
  variable VAR
  
  foreach Arg [list FR_emptyBox] \
  {  
    package require $Arg
  }
  
  set VAR(UnusedTransStop) 0
  
  set VAR(UnusedTransWindow) "unusedtrans_window"
 
  if {[winfo exists .$VAR(UnusedTransWindow)]} \
  {
     wm deiconify .$VAR(UnusedTransWindow)
  } \
  else \
  {
     ::FR_emptyBox::Create -window .$VAR(UnusedTransWindow) -title [msgcat::mc "List with unused translations"]
 
     labelframe .$VAR(UnusedTransWindow).frame1 -relief groove -text [msgcat::mc "Unused translations"] -foreground blue -padx 5 -pady 5
     frame .$VAR(UnusedTransWindow).frame2 -relief flat

     pack  .$VAR(UnusedTransWindow).frame1 -side top -expand yes -fill both -padx 5 -pady 5
     pack  .$VAR(UnusedTransWindow).frame2 -side top -fill x
 
     set mainframe $VAR(UnusedTransWindow).frame1
     set bottomframe $VAR(UnusedTransWindow).frame2
    
     button .$mainframe.refresh -text [msgcat::mc "Refresh the content:"] -command [list ::tk_msg::UnusedTransInputContent $mainframe]
      
     text .$mainframe.text -wrap none -background white -state disabled -xscrollcommand ".$mainframe.xsbar set" -yscrollcommand ".$mainframe.ysbar set"
     scrollbar .$mainframe.xsbar -orient horizontal -command ".$mainframe.text xview"
     scrollbar .$mainframe.ysbar -orient vertical -command ".$mainframe.text yview"
 
     grid .$mainframe.refresh -row 0 -column 0 -columnspan 2 -sticky ew -pady 5
     grid .$mainframe.text -row 1 -column 0 -sticky nsew
     grid .$mainframe.ysbar -row 1 -column 1 -sticky ns
     grid .$mainframe.xsbar -row 2 -column 0 -sticky ew
 
     grid columnconfigure .$mainframe 0 -weight 1
     grid rowconfigure .$mainframe 1 -weight 1
 
     # the bottom button     
     button .$bottomframe.dismiss -text [msgcat::mc "Dismiss"] -state normal -command [list ::tk_msg::UnusedTransSubExit]
               
     pack .$bottomframe.dismiss -side left -padx 5 -pady 5 -expand yes -fill x
  
     bind .$VAR(UnusedTransWindow) <KeyPress-Escape> [list .$bottomframe.dismiss invoke]
    
     wm protocol .$VAR(UnusedTransWindow) WM_DELETE_WINDOW [list .$bottomframe.dismiss invoke]
  }
  
  ::tk_msg::UnusedTransInputContent $mainframe
  
  wm deiconify .$VAR(UnusedTransWindow)
  
  vwait ::tk_msg::VAR(UnusedTransStop)
  return
}


#---clears the text widget and puts in the content
proc ::tk_msg::UnusedTransInputContent {widget} \
{
  variable VAR
  
  .$widget.text configure -state normal
  .$widget.text delete 1.0 end
  
  if {[llength $VAR(CatTranslationList)] > 0} \
  {
    foreach i $VAR(CatMsgList) j $VAR(CatTranslationList) \
    { 
      .$widget.text insert end "\"${i}\" \"${j}\"\n"
    }
  } \
  else \
  {
    .$widget.text insert end [msgcat::mc "There aren't any unused translations."]
  }
}


#---the bottom dismiss button
proc ::tk_msg::UnusedTransSubExit {} \
{
  variable VAR
 
  focus $VAR(Parent)
  
  destroy .$VAR(UnusedTransWindow)
  
  set VAR(UnusedTransStop) 1
}
